package com.jenfa;

import java.io.*;
import javax.microedition.io.*;
import com.motorola.io.*;

public class AsciiTextFile {

  InputStream is=null;
  DataInputStream dis=null;
  FileConnection fc = null;
  boolean opened=false;
  boolean eofoccured=false;
  byte [] filecont;
  int currentPos=0;
  char [] ascii2char =
{
   ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','!','"','#','$','%','&','\'','(',')','*','+',',','-','.','/','0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?','@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','[','\\',']','^','_','`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','{','|','}','~','','','','','','','','','','','','','','','','','','','','','','','','','','\u0098','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',
   '','',''
};

  public AsciiTextFile() {
  }

  public void openFile(String filename) throws Exception
  {
    try {
      int size=0;
      if (filename.startsWith("file://"))
      {
        fc = (FileConnection) Connector.open(filename);
        is = null;
        dis = fc.openDataInputStream();
        size = (int) fc.fileSize();
        opened = true; eofoccured = false;
      }
      else
      {
      is=getClass().getResourceAsStream(filename);
      dis = new DataInputStream(is);
      size = dis.available();
      }
      //System.out.println(size);
      filecont = readFileFully(dis,size);
      opened=true;
      eofoccured=false;

    }
    catch (Exception e) { Exception e2 = new Exception(e.toString() + " : at AsciiTextFile.open");  throw e2; }
  }

  public void openFile(String filename, int sz) throws Exception
  {
    try {
      int size=0;
      if (filename.startsWith("file://"))
      {
        fc = (FileConnection) Connector.open(filename);
        is = null;
        dis = fc.openDataInputStream();
        size = (int) fc.fileSize();
        opened = true; eofoccured = false;
      }
      else
      {
      is=getClass().getResourceAsStream(filename);
      dis = new DataInputStream(is);
      size = sz;
      }
      //System.out.println(size);
      filecont = readFileFully(dis,size);
      opened=true;
      eofoccured=false;

    }
    catch (Exception e) { Exception e2 = new Exception(e.toString() + " : at AsciiTextFile.open");  throw e2; }
  }

  public byte [] readFileFully(DataInputStream dis,int size) throws Exception
  {
    byte [] a = new byte[1];
    try {
      a = new byte[size];
      dis.readFully(a, 0, size);
    }
    catch (Exception e) { Exception e2 = new Exception(e.toString() + " : at AsciiTextFile.readFileFully");  throw e2; }
    return a;
  }

  public void close() throws Exception
  {
    if (opened)
    {
      try {
        //dis.close();

        if(!(is==null)) { is.close(); } else { dis.close(); }
        dis=null;
        is=null;
        opened=false;
        eofoccured=false;
      }
      catch (Exception e) { Exception e2 = new Exception(e.toString() + " : at AsciiTextFile.close");  throw e2; }
    }
    else
    {
      IllegalStateException ise=new IllegalStateException("file not opened");
      throw ise;
    }
  }

  public boolean eof() throws Exception
  {
    if (opened)
    {
      return eofoccured;
    }
    else
    {
      throw new IllegalStateException("file not opened");
    }
  }

  public String readLine() throws Exception
  {
    int a=0;
    String res="";
    if (opened)
    {
    while (a!=10 && !eofoccured)
    {
    try {
      a = filecont[currentPos];
      currentPos++;
      if (a<0) a=256+a;
      if (a!=13 && a!=10 && !eofoccured)
      {
      res = res + ascii2char[a];
      }
    }
    catch (ArrayIndexOutOfBoundsException aioobe) { eofoccured=true; }
    }//while
    }//if
    else
    {
      throw new IllegalStateException("file not opened");
    }
    return res;
  }


}