package com.jenfa;

import java.io.*;
import javax.microedition.io.*;
import com.motorola.io.*;

public class UTFTextFile {

  InputStream is=null;
  DataInputStream dis=null;
  FileConnection fc = null;
  boolean opened=false;
  boolean eofoccured=false;

  public UTFTextFile() {
  }

  public void openFile(String filename) throws Exception
  {
    try {
      if (filename.startsWith("file://"))
      {
        fc = (FileConnection) Connector.open(filename);
        is = null;
        dis = fc.openDataInputStream();
        opened = true; eofoccured = false;
      }
      else
      {
      is=getClass().getResourceAsStream(filename);
      dis = new DataInputStream(is);
      opened=true;
      eofoccured=false;
      }
    }
    catch (Exception e) { Exception e2 = new Exception(e.toString() + " : at AsciiTextFile.open");  throw e2; }
  }

  public void close() throws Exception
  {
    if (opened)
    {
      try {
        //dis.close();

        if(!(is==null)) { is.close(); } else { dis.close(); }
        dis=null;
        is=null;
        opened=false;
        eofoccured=false;
      }
      catch (Exception e) { Exception e2 = new Exception(e.toString() + " : at AsciiTextFile.close");  throw e2; }
    }
    else
    {
      IllegalStateException ise=new IllegalStateException("file not opened");
      throw ise;
    }
  }

  public boolean eof() throws Exception
  {
    if (opened)
    {
      return eofoccured;
    }
    else
    {
      throw new IllegalStateException("file not opened");
    }
  }

  public String readLine() throws Exception
  {
    String res="";
    if (opened)
    {
    try {
      res = dis.readUTF();
    }
    catch (EOFException eofe) { eofoccured=true; }
    }//if
    else
    {
      throw new IllegalStateException("file not opened");
    }
    return res;
  }


}