package fm;

import javax.microedition.lcdui.*;
import javax.microedition.media.control.*;
import javax.microedition.media.*;
import com.motorola.io.*;
import java.util.*;
import javax.microedition.io.*;
import java.io.*;

public class AudioPlayerUI extends Canvas implements PlayerListener, CommandListener, Runnable {

  Display disp;
  callback Callback;

  Player pl=null;

  boolean loaded = false;

  VolumeControl vc=null;
  PitchControl pc=null;
  RateControl rc=null;

  byte seek_step=0;
  byte volume_step=0;

  Random rnd;

  int volume=0;

  Command exit2 = new Command("", Command.ITEM, 3);

  int timeout=0;
  boolean show_info=true;
  boolean s_override_info=false;

  String info="";

  String override_info="";

  String filename;
  String filepath;

  boolean auto_scroll=false;
  boolean backlight=true;
  boolean random_scroll=false;

  boolean keyboard_locked = false;

  String total;
  String played;

  String [] audlist;
  int [] real_idxs;

  int index;

  SettingsHandler Sh;

  AudioPlayerRepaintControl aprc=new AudioPlayerRepaintControl(this);
  Command exit = new Command("", Command.EXIT, 1);

  Font song_title = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);

  public AudioPlayerUI(Display d, exec prev, String [] filelist, int [] ridxs,  int idx, SettingsHandler sh) {
    disp = d;
    Sh = sh;
    disp.flashBacklight(Integer.MAX_VALUE);
    Callback=prev;
    audlist = filelist;
    real_idxs = ridxs;
    index=idx;
    addCommand(exit);
    setCommandListener(this);
    volume = sh.volume;
    seek_step = sh.seek_step;
    volume_step = sh.volume_step;
    auto_scroll = sh.ap_auto_next;
    random_scroll = sh.ap_shuffle;
    rnd = new Random(System.currentTimeMillis());
  }

  public void run()
  {
    if (s_override_info)
    {
      timeout++;
      if (timeout==3)
      {
        s_override_info=false;
        timeout=0;
      }
    }
    repaint();
  }

  public void HandleError(Exception what, String where)
  {
    Alert ErrorOut = new Alert("Exception occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    ErrorOut.addCommand(exit2);
    System.err.println("[FILEMANAGER EXCEPTION]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void freeMem()
  {
    pl = null;
    song_title=null;
    vc = null;
    disp = null;
    System.gc();
  }

  protected void paint(Graphics g) {
    g.setColor(0,0,0);
    g.fillRect(0,0,getWidth(), getHeight());
    g.setColor(255,255,255);
    g.setFont(song_title);
    g.drawString(filename,1,1,0);
    if (pl.getState()==pl.REALIZED)
    {
      g.drawString("00:00"+"/"+millisecs2time(pl.getDuration()), 1, song_title.getHeight()+2, 0);
    }
    if (pl.getState()==pl.PREFETCHED)
    {
      g.drawString(millisecs2time(pl.getMediaTime())+"/"+millisecs2time(pl.getDuration()), 1, song_title.getHeight()+2, 0);
    }
    if (pl.getState()==pl.STARTED)
    {
      g.drawString(millisecs2time(pl.getMediaTime())+"/"+millisecs2time(pl.getDuration()), 1, song_title.getHeight()+2, 0);
    }
    if (show_info && !s_override_info)
    {
      g.drawString(info,1,song_title.getHeight()*2+4, 0);
    }
    if (s_override_info)
    {
      g.drawString(override_info,1,song_title.getHeight()*2+4, 0);
    }
  }

  protected void keyPressed(int keycode)
  {
  try {
  if (!keyboard_locked)
  {
  if (getGameAction(keycode)==Canvas.UP && keycode!=Canvas.KEY_NUM2)
    {
      boolean handled=false;
      if (pl.getState()==pl.PREFETCHED) { pl.start(); handled = true; }
      if (pl.getState()==pl.STARTED && !handled) { pl.stop(); handled=true; }
      if (pl.getState()==pl.REALIZED && !handled) { pl.prefetch(); pl.start(); handled=true; }
    }

    if (getGameAction(keycode)==Canvas.DOWN && keycode!=Canvas.KEY_NUM8)
    {
      if (pl.getState()==pl.PREFETCHED) { pl.setMediaTime(0); }
      if (pl.getState()==pl.STARTED) { pl.stop(); pl.setMediaTime(0); }
    }



    if (keycode==Canvas.KEY_NUM4)
   {
    long cur = pl.getMediaTime();
    long dur = pl.getDuration();
    long newt=cur-dur/(100/seek_step);
    if (newt<0) newt=0;
    pl.setMediaTime(newt);
    overrideInfo("");
   }

   if (keycode==Canvas.KEY_NUM6)
   {
    long cur = pl.getMediaTime();
    long dur = pl.getDuration();
    long newt=cur+dur/(100/seek_step);
    if (newt>=dur) newt=0;
    pl.setMediaTime(newt);
    overrideInfo("");
   }

  if (getGameAction(keycode)==Canvas.LEFT && keycode!=Canvas.KEY_NUM4)
  {
    if (!random_scroll)
    { index--; }
    else
    {
     int rnd_znac = rnd.nextInt();
     if (rnd_znac<0) rnd_znac = -1*rnd_znac;
     index = rnd_znac % audlist.length;
    }

    if (index<0) index=audlist.length - 1;
    pl.deallocate();
    try {
    openFile(audlist[index]);
    prepareFile();
    launchPlayer();
    }
    catch (Exception e) { HandleError(e, "keyPressed1"); }
  }

  if (getGameAction(keycode)==Canvas.RIGHT && keycode!=Canvas.KEY_NUM6)
  {
    if (!random_scroll)
    { index++; }
    else
    {
     int rnd_znac = rnd.nextInt();
     if (rnd_znac<0) rnd_znac = -1*rnd_znac;
     index = rnd_znac % audlist.length;
    }
    if (index>audlist.length-1) index=0;
    pl.deallocate();
    try {
    openFile(audlist[index]);
    prepareFile();
    launchPlayer();
    }
    catch (Exception e) { HandleError(e, "keyPressed2"); }
  }

   if (keycode==Canvas.KEY_STAR)
   {
   if (vc!=null)
   {
    volume = volume-volume_step;
    vc.setLevel(volume);
    volume = vc.getLevel();
    overrideInfo(": " + String.valueOf(volume) +"%");
   }
   else
   {
    overrideInfo("");
   }
   }

   if (keycode==Canvas.KEY_POUND)
   {
    if (vc!=null)
    {
    volume = volume+volume_step;
    vc.setLevel(volume);
    volume = vc.getLevel();
    overrideInfo(": " + String.valueOf(volume) +"%");
    }
    else
   {
    overrideInfo("");
   }
   }

   if (keycode==Canvas.KEY_NUM2)
   {
    if (vc!=null)
    {
    boolean muted = vc.isMuted();
    if (muted)
    {
      vc.setMute(false);
      overrideInfo("Unmuted");
    }
    else
    {
      vc.setMute(true);
      overrideInfo("Muted");
    }
    }
    else
   {
    overrideInfo("");
   }
   }

   /*if (keycode==Canvas.KEY_NUM4)
   {
   if (pc!=null)
   {
    pc.setPitch(pc.getPitch()-1000);
    overrideInfo("Pitch: "+String.valueOf(pc.getPitch()));
   }
   else
   {
    overrideInfo("");
   }
   }

   if (keycode==Canvas.KEY_NUM6)
   {
   if (pc!=null)
   {
    pc.setPitch(pc.getPitch()+1000);
    overrideInfo("Pitch: "+String.valueOf(pc.getPitch()));
   }
   else
   {
    overrideInfo("");
   }
   }*/

   if (keycode==Canvas.KEY_NUM7)
   {
   /*if (rc!=null)
   {
    rc.setRate(rc.getRate()-20000);
    overrideInfo("Rate: "+String.valueOf(rc.getRate()));
   }
   else
   {
    overrideInfo("");
   }*/
   auto_scroll=!auto_scroll;
   if (auto_scroll) overrideInfo(": ");
   if (!auto_scroll) overrideInfo(": ");
   }


   if (keycode==Canvas.KEY_NUM9)
   {
   /*if (rc!=null)
   {
    rc.setRate(rc.getRate()+20000);
    overrideInfo("Rate: "+String.valueOf(rc.getRate()));
   }
   else
   {
    overrideInfo("");
   }*/
   random_scroll = !random_scroll;
   if (random_scroll) overrideInfo("Shuffle: .");
   if (!random_scroll) overrideInfo("Shuffle: .");
   }

   if (keycode==Canvas.KEY_NUM8)
   {
    backlight = !backlight;
    if (backlight) { overrideInfo(": ."); disp.flashBacklight(Integer.MAX_VALUE); }  //Lighting.backlightOn(); }
    if (!backlight) { overrideInfo(": ."); disp.flashBacklight(0); }//  Lighting.backlightOff(); }
   }
   }

   if (keycode==Canvas.KEY_NUM0)
   {
    keyboard_locked = !keyboard_locked;
    if (keyboard_locked) overrideInfo(" : .");
    if (!keyboard_locked) overrideInfo(" : .");
   }
   }
   catch (Exception e) { System.err.println(e.toString() + " at AudioPlayerUI.keyPressed");}
  }

  void showInfo(String what)
  {
    info = what;
    show_info = true;
    timeout=0;
  }

  void overrideInfo(String what)
  {
    override_info = what;
    s_override_info = true;
    timeout=0;
  }

  public String millisecs2time(long millisecs)
  {
    long ts = millisecs/100000;
    return formatNumber(ts/600l, 2, true)+":"+formatNumber(((ts % 600) / 10), 2, true);
  }

  private String formatNumber(long num, int len, boolean leadingZeros) {
	StringBuffer ret=new StringBuffer(String.valueOf(num));
	if (leadingZeros) {
	    while (ret.length()<len) {
		ret.insert(0, '0');
	    }
	} else {
	    while (ret.length()<len) {
		ret.append('0');
	    }
	}
	return ret.toString();
    }

  public void openFile(String fname)
  {

    filepath = fname;
    filename = fname.substring(fname.lastIndexOf('/')+1);
    info = "";
  }

  public void prepareFile() throws Exception
  {
    try {
    SettingsHandler sh = new SettingsHandler(disp);
    sh.LoadSettings();
    pl = null;
    if (sh.useInputStreamInAudio)
    {
    FileConnection fc = (FileConnection) Connector.open("file://"+filepath);
    InputStream is = fc.openInputStream();
    pl = Manager.createPlayer(is, guessContentType("file://"+filepath));
    }
    else
    {
    pl = Manager.createPlayer("file:/"+filepath);
    }
    pl.addPlayerListener(this);
    pl.realize();
    info = "Realized";
    repaint();
    pl.prefetch();
    //is = null;
    //fc = null;
    vc = (VolumeControl) pl.getControl("VolumeControl");
    vc.setLevel(volume);
    pc = (PitchControl) pl.getControl("PitchControl");
    rc = (RateControl) pl.getControl("RateControl");

    info = "Prefetched";
    repaint();

    }
    catch (Exception e) { Exception e2=new Exception(e.toString() + " at AudioPlayerUI.prepareFile"); throw e2; }
    aprc = null;
    aprc = new AudioPlayerRepaintControl(this);
    aprc.StartProgramFlow(1,1000);
  }

  public void launchPlayer() throws Exception
  {
    repaint();
    try {
    pl.start();
    info = "";
    }
    catch (Exception e) {  Exception e2=new Exception(e.toString() + " at AudioPlayerUI.prepareFile"); throw e2; }
  }

  public void commandAction(Command c, Displayable d)
  {
    if (!keyboard_locked)
    {
    if (c==exit)
    {
      disp.flashBacklight(Integer.MAX_VALUE);
      try {
      if (pl.getState()==pl.STARTED) pl.stop();
      if (pl.getState()==pl.PREFETCHED) pl.deallocate();
      pl.close();
      }
      catch (Exception e) { }
      Sh.volume = (byte)volume;
      Sh.ap_auto_next = auto_scroll;
      Sh.ap_shuffle = random_scroll;
      Sh.SaveSettings();
      Sh = null;
      freeMem();
      Callback.viewer_callback(false,real_idxs[index],this);

    }
    }
  }

  public void playerUpdate(Player player, java.lang.String event, java.lang.Object eventData)
  {
    if (event == PlayerListener.END_OF_MEDIA)
    {
      if (!auto_scroll)
      {
      showInfo("");
      repaint();
      }
      else
      {
        keyPressed(this.getKeyCode(Canvas.LEFT));
      }
    }
    if (event==PlayerListener.ERROR)
    {
      showInfo("");
      repaint();
    }
    if (event==PlayerListener.CLOSED)
    {
      showInfo("");
      repaint();
    }
    if (event==PlayerListener.STARTED)
    {
      showInfo("");
      repaint();
    }
    if (event==PlayerListener.STOPPED)
    {
      showInfo("");
      repaint();
    }
  }

  public static String[] splitURL(String url) throws Exception {
	StringBuffer u=new StringBuffer(url);
	String[] result=new String[6];
	for (int i=0; i<=5; i++) {
	    result[i]="";
	}
	// get protocol
	boolean protFound=false;
	int index=url.indexOf(":");
	if (index>0) {
	    result[0]=url.substring(0, index);
	    u.delete(0, index+1);
	    protFound=true;
	}
	else if (index==0) {
	    throw new Exception("url format error - protocol");
	}
	// check for host/port
	if (u.length()>2 && u.charAt(0)=='/' && u.charAt(1)=='/') {
	    // found domain part
	    u.delete(0, 2);
	    int slash=u.toString().indexOf('/');
	    if (slash<0) {
		slash=u.length();
	    }
	    int colon=u.toString().indexOf(':');
	    int endIndex=slash;
	    if (colon>=0) {
		if (colon>slash) {
		    throw new Exception("url format error - port");
		}
		endIndex=colon;
		result[2]=u.toString().substring(colon+1, slash);
	    }
	    result[1]=u.toString().substring(0, endIndex);
	    u.delete(0, slash);
	}
	// get filename
	if (u.length()>0) {
	    url=u.toString();
	    int slash=url.lastIndexOf('/');
	    if (slash>0) {
		result[3]=url.substring(0, slash);
	    }
	    if (slash<url.length()-1) {
		String fn = url.substring(slash+1, url.length());
		int anchorIndex = fn.indexOf("#");
		if (anchorIndex>=0) {
		    result[4] = fn.substring(0, anchorIndex);
		    result[5] = fn.substring(anchorIndex+1);
		} else {
		    result[4] = fn;
		}
	    }
	}
	return result;
    }

  public static String guessContentType(String url) throws Exception {
	// guess content type
	String[] sURL = splitURL(url);
	String ext = "";
	String ct = "";
	int lastDot = sURL[4].lastIndexOf('.');
	if (lastDot>=0) {
	    ext = sURL[4].substring(lastDot+1).toLowerCase();
	}
	//if (ext.equals("mpg") || url.equals("avi")) {
	//    ct = "video/mpeg";
	if (ext.equals("mid") || ext.equals("kar") || ext.equals("midi") || ext.equals("bas")) {
	    ct = "audio/midi";
	} else if (ext.equals("wav")) {
	    ct = "audio/x-wav";
	} else if (ext.equals("jts")) {
	    ct = "audio/x-tone-seq";
	} else if (ext.equals("txt")) {
	    ct = "audio/x-txt";
	} else if (ext.equals("amr")) {
	    ct = "audio/amr";
	} else if (ext.equals("awb")) {
	    ct = "audio/amr-wb";
	} else if (ext.equals("gif")) {
	    ct = "image/gif";
	} else if (ext.equals("mp3")) {
            ct = "audio/mpeg";
        }
	return ct;
    }


}