package fm;

import javax.microedition.rms.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;

public class BookmarksHandler implements CommandListener {

  RecordStore rs;

  callback clb;
  Display disp;

  String curdir;

  List bookmarks_lst;

  int [] idxs;

  Command open = new Command("", Command.ITEM, 2);
  Command close = new Command("", Command.CANCEL, 2);
  Command add = new Command("", Command.ITEM, 2);
  Command del = new Command("", Command.ITEM, 2);

  Command add_ok = new Command("OK", Command.OK, 1);
  Command add_no = new Command("", Command.CANCEL, 1);

  TextBox add_name;

  public BookmarksHandler(Display d, callback Callback, String crd) {
    clb = Callback;
    disp = d;
    curdir = crd;
  }

  public void showBookmarks()
  {
    int [] tmp = new int[100];
    int cnt=0;
    ByteArrayInputStream bis;
    DataInputStream dis;
    bookmarks_lst = new List("",List.IMPLICIT);
    bookmarks_lst.addCommand(open);
    bookmarks_lst.addCommand(close);
    bookmarks_lst.addCommand(add);
    bookmarks_lst.addCommand(del);
    RecordEnumeration re;
    try {
      rs = RecordStore.openRecordStore("fm_bookmarks",true);
      re = rs.enumerateRecords(null, null, false);
      while (re.hasNextElement())
      {
        int a = re.nextRecordId();
        bis = new ByteArrayInputStream(rs.getRecord(a));
        dis = new DataInputStream(bis);
        bookmarks_lst.append(dis.readUTF(),null);
        bis.close();
        dis = null; bis = null;
        cnt++;
        tmp[cnt]=a;
      }
      rs.closeRecordStore();
      rs=null;
      idxs = new int[cnt+1];
      System.arraycopy(tmp, 0, idxs, 0, cnt+1);
      tmp = null;
    }
    catch (Exception e) { HandleError(e,"showBookmarks"); }
    bookmarks_lst.setCommandListener(this);
    disp.setCurrent(bookmarks_lst);
  }

  void AddBookmark_exec()
  {
    try {
      rs = RecordStore.openRecordStore("fm_bookmarks",true);
      ByteArrayOutputStream bos = new ByteArrayOutputStream();
      DataOutputStream dos = new DataOutputStream(bos);
      dos.writeUTF(add_name.getString());
      byte [] a = bos.toByteArray();
      rs.addRecord(a, 0, a.length);
      a = null;
      bos.close();
      dos = null;
      bos = null;
      rs.closeRecordStore();
      showBookmarks();
    }
    catch (Exception e) { HandleError(e,"AddBookmark_exec"); }
  }

  void AddBookmark()
  {
    add_name = new TextBox("",curdir,255,TextField.URL);
    add_name.addCommand(add_ok);
    add_name.addCommand(add_no);
    add_name.setCommandListener(this);
    disp.setCurrent(add_name);
  }

  void deleteBookmark()
  {
      try {
        rs = RecordStore.openRecordStore("fm_bookmarks",true);
        rs.deleteRecord(idxs[bookmarks_lst.getSelectedIndex()+1]);
        rs.closeRecordStore();
        showBookmarks();
      }
      catch (Exception e) { HandleError(e,"deleteBookmark"); }
  }


  public void HandleError(Exception what, String where)
  {
    Alert ErrorOut = new Alert("Exception occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    System.err.println("[FILEMANAGER EXCEPTION]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void HandleError2(Error what, String where)
  {
    Alert ErrorOut = new Alert("Error occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    System.err.println("[FILEMANAGER ERROR]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void commandAction(Command c, Displayable d)
  {
    if (c==List.SELECT_COMMAND && d==bookmarks_lst)
    {
      clb.bookmarks_callback(bookmarks_lst.getString(bookmarks_lst.getSelectedIndex()),this,true);
    }
    if (c==add) AddBookmark();
    if (c==add_ok) AddBookmark_exec();
    if (c==add_no) disp.setCurrent(bookmarks_lst);
    if (c==del) deleteBookmark();
    if (c==open) clb.bookmarks_callback(bookmarks_lst.getString(bookmarks_lst.getSelectedIndex()),this,false);
    if (c==close) clb.callback_no_free_mem(this);
  }
}