package fm;

import com.jenfa.*;
import javax.microedition.lcdui.*;

public class FileViewerUI implements CommandListener{

  callback Callback;
  Display disp;

  String filename = null;

  int viewType=0;

  public static int VIEW_ASCII=1;
  public static int VIEW_HEX=2;
  public static int VIEW_UTF=3;

  Command close=new Command("", Command.EXIT, 1);
  Command empty=new Command("", Command.ITEM, 1);
  Command show_as_ascii = new Command(" ASCII",Command.ITEM, 1);
  Command show_as_hex = new Command(" HEX", Command.ITEM, 1);
  Command show_as_utf = new Command(" UTF", Command.ITEM, 1);

  public FileViewerUI(Display d, callback prev) {
    disp = d;
    Callback = prev;
  }

  public void setFile(String fname, int initialViewType)
  {
    if (initialViewType==VIEW_ASCII)
    {
      filename = fname;
      setViewType(VIEW_ASCII);
    }
  }

  public void setViewType(int to)
  {
    viewType=to;
  }

  public void HandleError(Exception what, String where)
  {
    Alert ErrorOut = new Alert("Exception occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    System.err.println("[FILEMANAGER EXCEPTION]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void HandleError2(Error what, String where)
  {
    Alert ErrorOut = new Alert("Error occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    System.err.println("[FILEMANAGER ERROR]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void viewFile() throws Exception
  {
     Form out = new Form(filename.substring(7));
    try {

      if (viewType==VIEW_ASCII)
      {
        String ll="";
        AsciiTextFile atf = new AsciiTextFile();
        atf.openFile(filename);
        while (!atf.eof())
        {
          ll=ll+atf.readLine();
          ll=ll+"\n";

        }
        out.append(ll);
        atf.close();
        atf = null;
      }

      if (viewType==VIEW_UTF)
      {
        UTFTextFile utf = new UTFTextFile();
        utf.openFile(filename);
        while(!utf.eof())
        {
          out.append(utf.readLine() + "\n");
        }
        utf.close();
        utf = null;
      }

      }
      catch (Exception e) { Exception e2 = new Exception(e.toString() + " at FileViewerUI.viewFile"); throw e2; }
      out.addCommand(empty);
      out.addCommand(close);
      out.addCommand(show_as_ascii);
      out.addCommand(show_as_hex);
      out.addCommand(show_as_utf);
      out.setCommandListener(this);
      disp.setCurrent(out);
  }

  public void commandAction(Command c, Displayable d)
  {
    if (c==close)
    {
      System.gc();
      Callback.callback(false,this);
    }
    if (c==show_as_ascii)
    {
      setViewType(VIEW_ASCII);
      try {
      viewFile();
      }
      catch (Exception e) { HandleError(e, ""); }
    }
    if (c==show_as_utf)
    {
      setViewType(VIEW_UTF);
      try {
      viewFile();
      }
      catch (Exception e) { HandleError(e, ""); }
    }
  }
}