package fm;

import javax.microedition.rms.*;
import java.io.*;

public class HiddenFilesHandler {

  RecordStore rs = null;

  public HiddenFilesHandler() {
  }

  public void hideFile(String directory, String fname) throws Exception
  {
  try {
    rs = RecordStore.openRecordStore("fm_hiddenfiles", true);
    ByteArrayOutputStream bos = new ByteArrayOutputStream();
    DataOutputStream dos = new DataOutputStream(bos);
    dos.writeUTF(directory);
    dos.writeUTF(fname);
    byte [] a = bos.toByteArray();
    rs.addRecord(a, 0, a.length);
    //System.out.println("ADDED REC");
    a = null;
    bos.close();
    dos = null;
    bos = null;
    rs.closeRecordStore();
    rs = null;
  }
  catch (Exception e) { Exception e2 = new Exception(e.toString() + " occured at HiddenFilesHandler.hideFile"); throw e2; }
  }

  /*public void Sync(String target_rs, String target_midlet, String target_vendor) throws Exception
  /*{
    try {
    int id=0;
    rs = RecordStore.openRecordStore(target_rs, target_midlet, target_vendor);
    rs2 = RecordStore.openRecordStore("fm_hiddenfiles", true, RecordStore.AUTHMODE_ANY, true);
    RecordEnumeration re = rs2.enumerateRecords(null, null, true);
    while (re.hasNextElement())
    {
      id = re.nextRecordId();
      rs.deleteRecord(id);
    }
    RecordEnumeration re = rs.enumerateRecords(null,null,true);
    rs.closeRecordStore();
    re = null;
    rs = null;
    }
    catch (Exception e) { }
  }*/

  public void unHideFile(String directory, String fname) throws Exception
  {
  try {
    ByteArrayInputStream bis=null;
    DataInputStream dis=null;
    int id=0;
    rs = RecordStore.openRecordStore("fm_hiddenfiles", true);
    RecordEnumeration re = rs.enumerateRecords(null, null, true);
    while (re.hasNextElement())
    {
      id = re.nextRecordId();
      bis = new ByteArrayInputStream(rs.getRecord(id));
      dis = new DataInputStream(bis);
      if (dis.readUTF().compareTo(directory)==0 && dis.readUTF().compareTo(fname)==0)
      {
        rs.deleteRecord(id);
        //System.out.println("DELETED REC#"+id);
      }
      dis.close();
      bis.close();
      dis=null;
      bis=null;
    }
    rs.closeRecordStore();
    re = null;
    rs = null;
  }
  catch (Exception e) {  Exception e2 = new Exception(e.toString() + " occured at HiddenFilesHandler.getHiddenFiles"); throw e2; }
  }

  public String [] getHiddenFiles(String directory) throws Exception
  {
    try {
    ByteArrayInputStream bis=null;
    DataInputStream dis=null;
    String [] res = new String[1000];
    int point=0;
    res[0]="";
    rs = RecordStore.openRecordStore("fm_hiddenfiles", true);
    RecordEnumeration re = rs.enumerateRecords(null, null, true);
    while (re.hasNextElement())
    {
      bis = new ByteArrayInputStream(re.nextRecord());
      dis = new DataInputStream(bis);
      if (dis.readUTF().compareTo(directory)==0)
      {
        point++;
        res[point] = dis.readUTF();
      }
      dis.close();
      bis.close();
      dis=null;
      bis=null;
    }
    rs.closeRecordStore();
    re = null;
    rs = null;
    String [] res2 = new String[point+1];
    System.arraycopy(res,0,res2,0,point+1);
    res=null;
    System.gc();

    return res2;
    }
    catch (Exception e) {  Exception e2 = new Exception(e.toString() + " occured at HiddenFilesHandler.getHiddenFiles"); throw e2; }
  }
}