package fm;

import javax.microedition.lcdui.*;
import com.motorola.extensions.ScalableJPGImage;
import com.motorola.io.*;
import javax.microedition.io.*;
import java.io.*;
import javax.microedition.lcdui.game.Sprite;

public class ImageViewerUI extends Canvas {

  int [] p_width = new int[3];
  int [] p_height = new int[3];

  int [] widths_176204 = { 176, 272, 320 };
  int [] heights_176204 = { 235, 204, 240 };

  int [] widths_128128 = { 128, 160, 320 };
  int [] heights_128128 = { 96, 120, 240 };

  int cur_w=0;
  int cur_h=0;
  int curposx=0;
  int curposy=0;

  byte rotate = 0;

  int width=0;
  int height=0;

  Sprite rotator=null;

  ScalableJPGImage sjpgimage = null;

  byte [] img_store;
  boolean image_loaded=false;
  Display disp;

  String [] piclist;

  int [] real_idxs;

  callback Callback;

  int index;

  public ImageViewerUI(Display d, exec prev, String [] filelist, int [] ridxs, int idx) {
    disp = d;
    Callback=prev;
    piclist = filelist;
    setFullScreenMode(true);
    index=idx;
    SettingsHandler sh = new SettingsHandler(disp);
    sh.LoadSettings();
    cur_w = sh.im_width;
    cur_h = sh.im_height;
    rotate = sh.im_rotate;
    sh = null;
    real_idxs = ridxs;
  }

  protected void paint(Graphics g) {
    try {
    g.setColor(255,255,255);
    g.fillRect(0,0,getWidth(), getHeight());
    if (image_loaded)
    {
      rotator.setPosition(curposx,curposy);
      rotator.paint(g);
      //g.setColor(0,0,0);
      //g.setFont(Font.getDefaultFont());
      //g.drawString(String.valueOf(width) +"x"+String.valueOf(height), 0,0,0);
    }
    }
    catch (Exception e) { HandleError(e, "ImageViewerUI.paint"); }
  }

  void placeImageToCenter()
  {
    curposx = -1*width/2;
    curposx = curposx+getWidth()/2;
    curposy = -1*height/2;
    curposy = curposy + getHeight()/2;
    //curposx=getWidth()/2-width/2;
    //curposy=getHeight()/2-height/2;

  }

  public void setImage(byte [] data)
  {
  try {
  try {
    //cur_w = 0; cur_h=0;
    curposx=0; curposy=0; width=0; height=0;
    //if (getWidth()==176) { cur_w=2; cur_h=2; }
    if (getWidth()==128)
    {
      System.arraycopy(widths_128128, 0, p_width, 0, 3);
      System.arraycopy(heights_128128, 0, p_height, 0, 3);
    }
    else
    {
      System.arraycopy(widths_176204, 0, p_width, 0, 3);
      System.arraycopy(heights_176204, 0, p_height, 0, 3);
    }
    sjpgimage = ScalableJPGImage.createImage(data, 0, data.length, p_width[cur_w], p_height[cur_h]);
    width = sjpgimage.getImage().getWidth();
    height = sjpgimage.getImage().getHeight();

    rotator = new Sprite(sjpgimage.getImage());
    placeImageToCenter();
    sjpgimage = null;
    image_loaded=true;
    img_store = data;
    data = new byte[0];
    if (rotate==0)
    {
      execRotate(false);
    }
    else
    {
      execRotate(true);
    }
    System.gc();
  }
  catch (Error e) { HandleError2(e, "ImageViewerUI.setImage"); }
  }
  catch (Exception e) { HandleError(e, "ImageViewerUI.setImage" ); }
  }

  void resampleImage()
  {
    try {
    curposx=0; curposy=0;
    sjpgimage = ScalableJPGImage.createImage(img_store, 0, img_store.length, p_width[cur_w], p_height[cur_h]);
    width = sjpgimage.getImage().getWidth();
    height = sjpgimage.getImage().getHeight();
    rotator = new Sprite(sjpgimage.getImage());
    sjpgimage = null;
    execRotate(false);
    placeImageToCenter();
    this.repaint();
    System.gc();
    }
    catch (Error e) { HandleError2(e, "ImageViewerUI.resampleImage : desired dimensions: " + String.valueOf(p_width[cur_w])+"x"+String.valueOf(p_height[cur_h])); }
  }

  public void HandleError(Exception what, String where)
  {
    Alert ErrorOut = new Alert("Exception occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    System.err.println("[FILEMANAGER EXCEPTION]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void HandleError2(Error what, String where)
  {
    Alert ErrorOut = new Alert("Error occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    System.err.println("[FILEMANAGER ERROR]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  protected void freeMem()
  {
    p_width = null;
    p_height = null;
    sjpgimage = null;
    img_store = null;
    disp = null;
    System.gc();
  }

  public byte [] readFileFully(String filename)
  {
    byte [] a = new byte[0];
    try {
      //System.out.println(filename);
      FileConnection fc = (FileConnection) Connector.open("file://"+filename);
      int size = (int) fc.fileSize();
      a = new byte[size];
      DataInputStream dis = fc.openDataInputStream();
      dis.readFully(a, 0, size);
      dis.close();
      fc.close();
    }
    catch (Exception e) { HandleError(e, "ImageViewerUI.readFileFully"); }
    return a;
  }

  public void execRotate(boolean toggleDimensions)
  {
    try {
    try {
    if (rotate==2) rotator.setTransform(Sprite.TRANS_ROT270);
    if (rotate==1) rotator.setTransform(Sprite.TRANS_ROT90);
    if (rotate==0) rotator.setTransform(Sprite.TRANS_NONE);
    if (toggleDimensions)
    {
    int r = height;
    height=width;
    width=r;
    }
    }
    catch (Error e) { HandleError2(e, "ImageViewerUI.execRotate"); }
    }
    catch (Exception e) { HandleError(e, "ImageViewerUI.execRotate"); }
    placeImageToCenter();
  }

  void unload()
  {
    /*SettingsHandler sh = new SettingsHandler(disp);
    sh.LoadSettings();
    sh.im_height = (byte) cur_h;
    sh.im_rotate = rotate;
    sh.im_width = (byte) cur_w;
    sh.SaveSettings();
    sh = null;*/
    freeMem();
  }

  protected void keyPressed(int keycode)
  {
  if (keycode == Canvas.KEY_STAR)
  {
    if (rotate==2)
    {
      rotate=1;
      execRotate(false);
    }
    else
    {
      rotate--;
      if (rotate<0) rotate=2;
      execRotate(true);
    }
    repaint();
  }

  if (keycode == Canvas.KEY_POUND)
  {
    if (rotate==1)
    {
      rotate=2;
      execRotate(false);
    }
    else
    {
      rotate++;
      if (rotate>2) rotate=0;
      execRotate(true);
    }
    repaint();
  }

  if (keycode==Canvas.KEY_NUM3)
  {
    cur_w++;
    cur_h++;
    if (cur_w>2) cur_w=2;
    if (cur_h>2) cur_h=2;
    resampleImage();
  }
  if (keycode==Canvas.KEY_NUM9)
  {

    cur_w--;
    cur_h--;
    if (cur_w<0) cur_w=0;
    if (cur_h<0) cur_h=0;
    resampleImage();
  }
  if (keycode==Canvas.KEY_NUM4)
  {
    curposx=curposx+30;
    if (curposx>=0) curposx = 0;
    repaint();
  }
  if (keycode==Canvas.KEY_NUM6)
  {
    curposx=curposx-30;
    if (curposx<-1*(width-getWidth())) { curposx = -1*(width-getWidth()); if (curposx>0) curposx=0; }
    repaint();
  }
  if (keycode==Canvas.KEY_NUM2)
  {
    curposy = curposy+30;
    if (curposy>=0) curposy = 0;
    repaint();
  }
  if (keycode==Canvas.KEY_NUM8)
  {
    curposy = curposy-30;
    if (curposy<-1*(height-getHeight())) { curposy = -1*(height-getHeight()); if (curposy>0) curposy=0; }
    repaint();
  }

  /*if (keycode==Canvas.KEY_POUND)
  {
    unload();
    Callback.callback(false,this);
  }*/

  if (getGameAction(keycode)==Canvas.UP && keycode!=Canvas.KEY_NUM2)
  {
    index--;
    if (index<0) index=piclist.length - 1;
    setImage(readFileFully(piclist[index]));
    repaint();
  }

  if (getGameAction(keycode)==Canvas.DOWN && keycode!=Canvas.KEY_NUM8)
  {
    index++;
    if (index>piclist.length-1) index=0;
    setImage(readFileFully(piclist[index]));
    repaint();
  }

  if (keycode==-21 || keycode==21)
  {
    unload();
    Callback.viewer_callback(true,real_idxs[index],this);
  }
  }

  protected void keyRepeated(int keycode)
  {
  if (keycode==Canvas.KEY_NUM4)
  {
    curposx=curposx+30;
    //if (curposx>=0) curposx = 0;
    repaint();
  }

  if (keycode==Canvas.KEY_NUM6)
  {
    curposx=curposx-30;
    //if (curposx<-1*width) curposx = -1*width;
    repaint();
  }

  if (keycode==Canvas.KEY_NUM2)
  {
    curposy = curposy+30;
    //if (curposy>=0) curposy = 0;
    repaint();
  }

  if (keycode==Canvas.KEY_NUM8)
  {
    curposy = curposy-30;
    //if (curposy<-1*height) curposy = -1*height;
    repaint();
  }
  }
}
