package fm;

import javax.microedition.rms.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;

public class SettingsHandler implements CommandListener {

  Displayable cb = null;
  ChoiceGroup cg;
  ChoiceGroup resolution;
  ChoiceGroup rot;
  ChoiceGroup sort;

  TextField s_dir;
  TextField tf_seek_step;
  TextField tf_volume_step;

  boolean showtree = false;
  boolean useInputStreamInAudio = false;
  boolean scrollImages = true;
  boolean scrollAudio = true;

  boolean show_hidden_files = true;

  boolean show_hidden_dirs = true;
  boolean ap_shuffle = false;
  boolean ap_auto_next = false;
  boolean jpg_preview = false;
  boolean icons = true;
  byte im_rotate = 0;
  byte im_width = 0;
  byte im_height = 0;
  byte volume=50;
  byte sort_files=0;

  byte seek_step = 5;
  byte volume_step = 4;

  String start_dir="mobile/";

  Command exit = new Command("", Command.ITEM, 3);
  Command ok = new Command("OK",Command.OK,1);
  Command cancel = new Command("",Command.CANCEL, 1);

  Display disp;

  public SettingsHandler(Display d) {
    disp = d;
  }

  public void LoadSettings()
  {
    showtree = false;
    useInputStreamInAudio = false;
    try {
    RecordStore rs = RecordStore.openRecordStore("fm_settings",true);
    RecordEnumeration re = rs.enumerateRecords(null,null,false);
    if (re.hasNextElement())
    {
      ByteArrayInputStream bis = new ByteArrayInputStream(re.nextRecord());
      DataInputStream dis = new DataInputStream(bis);
      showtree = dis.readBoolean();
      useInputStreamInAudio = dis.readBoolean();
      scrollImages = dis.readBoolean();
      scrollAudio = dis.readBoolean();
      jpg_preview = dis.readBoolean();
      im_width = dis.readByte();
      im_height = dis.readByte();
      volume = dis.readByte();
      im_rotate = dis.readByte();
      show_hidden_dirs = dis.readBoolean();
      sort_files = dis.readByte();
      start_dir = dis.readUTF();
      seek_step = dis.readByte();
      volume_step = dis.readByte();
      icons = dis.readBoolean();
      show_hidden_files = dis.readBoolean();
      ap_shuffle = dis.readBoolean();
      ap_auto_next = dis.readBoolean();
    }
    rs.closeRecordStore();
    }
    catch (Exception e) { if(!(e instanceof EOFException)) HandleError(e, "LoadSettings"); }

  }

  public void SaveSettings()
  {
    try {
    RecordStore rs = RecordStore.openRecordStore("fm_settings", true);
    RecordEnumeration re = rs.enumerateRecords(null,null,false);
    while(re.hasNextElement()) { rs.deleteRecord(re.nextRecordId()); }
    ByteArrayOutputStream bos = new ByteArrayOutputStream();
    DataOutputStream dos = new DataOutputStream(bos);
    dos.writeBoolean(showtree);
    dos.writeBoolean(useInputStreamInAudio);
    dos.writeBoolean(scrollImages);
    dos.writeBoolean(scrollAudio);
    dos.writeBoolean(jpg_preview);
    dos.writeByte(im_width);
    dos.writeByte(im_height);
    dos.writeByte(volume);
    dos.writeByte(im_rotate);
    dos.writeBoolean(show_hidden_dirs);
    dos.writeByte(sort_files);
    dos.writeUTF(start_dir);
    dos.writeByte(seek_step);
    dos.writeByte(volume_step);
    dos.writeBoolean(icons);
    dos.writeBoolean(show_hidden_files);
    dos.writeBoolean(ap_shuffle);
    dos.writeBoolean(ap_auto_next);
    byte [] a = bos.toByteArray();
    rs.addRecord(a, 0, a.length);
    a = null;
    bos.close();
    dos = null;
    bos = null;
    rs.closeRecordStore();
    rs = null;
    }
    catch (Exception e) { HandleError(e,"SaveSettings"); }
  }

  void HandleError(Exception what, String where)
  {
    Alert ErrorOut = new Alert("Exception occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    ErrorOut.addCommand(exit);
    System.err.println("[FILEMANAGER EXCEPTION]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }



  public void ChangeSettings(Displayable callback)
  {
    cb = callback;
    Form form = new Form("");
    cg = new ChoiceGroup("", ChoiceGroup.MULTIPLE);
    cg.append("   ", null);
    cg.append(" InputStream  AudioPlayer",null);
    cg.append("   Image Viewer",null);
    cg.append("   Audio Player",null);
    cg.append(" JPG-",null);
    cg.append("  ",null);
    cg.append("   ",null);
    cg.append("  ",null);
    cg.setSelectedIndex(0,showtree);
    cg.setSelectedIndex(1, useInputStreamInAudio);
    cg.setSelectedIndex(2, scrollImages);
    cg.setSelectedIndex(3, scrollAudio);
    cg.setSelectedIndex(4, jpg_preview);
    cg.setSelectedIndex(5,show_hidden_dirs);
    cg.setSelectedIndex(6,icons);
    cg.setSelectedIndex(7,show_hidden_files);
    sort = new ChoiceGroup("",Choice.EXCLUSIVE);
    sort.append("",null);
    sort.append(":  ",null);
    sort.append(":  ",null);
    sort.append(":  ",null);
    sort.append(":  ",null);
    sort.append(" (2 ):  ",null);
    sort.append(" (2 ):  ",null);
    sort.setSelectedIndex(sort_files,true);
    resolution = new ChoiceGroup("   ImageViewer", Choice.EXCLUSIVE);
    DimensionsCollector dc = new DimensionsCollector();
    if (dc.getWidth()!=128)
    {
      resolution.append("176x235 (235x176)", null);
      resolution.append("272x204 (204x272)", null);
      resolution.append("320x240 (240x320)", null);
    }
    else
    {
      resolution.append("128x96 (96x128)", null);
      resolution.append("160x120 (120x160)", null);
      resolution.append("320x240 (240x320)", null);
    }
    resolution.setSelectedIndex(im_width,true);
    rot = new ChoiceGroup("   ImageViewer", Choice.EXCLUSIVE);
    rot.append("0 ",null);
    rot.append("90 ",null);
    rot.append("270 ",null);
    rot.setSelectedIndex(im_rotate,true);
    s_dir = new TextField(" : ",start_dir, 255, TextField.ANY);
    tf_seek_step = new TextField("   %", String.valueOf(seek_step), 255, TextField.NUMERIC);
    tf_volume_step = new TextField("  ", String.valueOf(volume_step), 255, TextField.NUMERIC);
    form.append(cg);
    form.append(sort);
    form.append(resolution);
    form.append(rot);
    form.append(s_dir);
    form.append(tf_seek_step);
    form.append(tf_volume_step);
    form.addCommand(ok);
    form.addCommand(cancel);
    form.setCommandListener(this);
    disp.setCurrent(form);
  }

  public void Callback()
  {
    cg=null;
    disp.setCurrent(cb);
  }

  public void commandAction(Command c, Displayable d)
  {
    if(c==ok)
    {
      showtree = cg.isSelected(0);
      useInputStreamInAudio = cg.isSelected(1);
      scrollImages = cg.isSelected(2);
      scrollAudio = cg.isSelected(3);
      jpg_preview = cg.isSelected(4);
      show_hidden_dirs = cg.isSelected(5);
      icons = cg.isSelected(6);
      show_hidden_files = cg.isSelected(7);
      sort_files = (byte)sort.getSelectedIndex();
      im_width = (byte)resolution.getSelectedIndex();
      im_height = (byte)resolution.getSelectedIndex();
      im_rotate = (byte)rot.getSelectedIndex();
      start_dir = s_dir.getString();
      seek_step = Byte.parseByte(tf_seek_step.getString());
      volume_step = Byte.parseByte(tf_volume_step.getString());
      SaveSettings();
      Callback();
    }
    if (c==cancel) Callback();
  }
}