package fm;

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import com.motorola.io.*;
import com.jenfa.AsciiTextFile;
import javax.microedition.io.*;
import java.io.*;
import javax.microedition.rms.*;

public class TreeUI extends Canvas implements CommandListener{

  char [] ascii = { ' ',' ','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9',
  '','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','' };

  Image font;
  Image fold_sm;

  boolean updated;

  static int SYMBOL_WIDTH=6;
  static int SYMBOL_HEIGHT=10;

  int s_line=0;
  int line_y=0;
  int p_line=0;

  int im_y=0;

  static int SKIP_LEN=10;

  int line=0;

  Image tree=null;

  int width=0;
  int height=0;

  boolean exiting = false;

  int i=0;

  String root="";

  String [] dirs_list=null;
  int [] dirs_skip = null;
  String [] dirs_tmp = null;
  int [] skip_tmp = null;

  int g_point=0;

  Command exit = new Command("", Command.ITEM, 3);
  Command update = new Command("", Command.ITEM, 2);

  FileConnection fc=null;

  Display disp;

  callback Callback=null;

  public TreeUI(Display d, callback c, String cur_root) {
    try { font = Image.createImage("/graphics/font.png"); fold_sm=Image.createImage("/graphics/folder_sm.png"); } catch (Exception e) { HandleError(e,"TreeUI Constructor"); }
    this.setFullScreenMode(true);
    disp=d;
    Callback = c;
    root = cur_root;
    addCommand(exit);
    addCommand(update);
    setCommandListener(this);
    ReadTreeFromRMS();

/*    Graphics g = getGraphics();
    g.setColor(0,0,255);
    g.drawLine(0,0,getWidth(),0);
    g.drawLine(0,SYMBOL_HEIGHT,getWidth(),SYMBOL_HEIGHT);*/

    enterMainLoop();
  }

  void UpdateTree()
  {
    initVariables();
    updated = true;
    dirs_tmp[0]="/ /";
    skip_tmp[0]=0;
    dirs_tmp[1]="//";
    skip_tmp[1]=0;
    g_point=2;
    RenderTree(root, 0, true);
  }

  void initVariables()
  {
    tree=null;
    dirs_skip = null;
    dirs_tmp = null;
    skip_tmp = null;
    updated = false;
    dirs_list = new String[0];
    dirs_skip = new int[0];
    dirs_tmp = new String[1000];
    skip_tmp = new int[1000];
    s_line=0;
    line_y=0;
    p_line=0;

    im_y=0;

    line=0;
    g_point=0;
  }

  void ReadTreeFromRMS()
  {
    boolean read = true;
    RecordStore rs=null;
    try {
    rs = RecordStore.openRecordStore("tree"+root,false);
    }
    catch (Exception e)
    {
      if (e instanceof RecordStoreNotFoundException)
      {
        read=false;
        UpdateTree();
      }
      else
      {
        HandleError(e, "ReadTreeFromRMS");
      }
    }
    if (read)
    {
    initVariables();
    try {
      ByteArrayInputStream bis = null;
      DataInputStream dis=null;
      RecordEnumeration re = rs.enumerateRecords(null,null,true);
      while(re.hasNextElement())
      {
        bis = new ByteArrayInputStream(re.nextRecord());
        dis = new DataInputStream(bis);
        dirs_tmp[g_point] = dis.readUTF();
        skip_tmp[g_point] = dis.readInt();
        //System.out.println("READ " + dirs_tmp[g_point] + ", skip: " + String.valueOf(skip_tmp[g_point]) + " g_point="+String.valueOf(g_point));
        g_point++;
        bis.close();
        bis = null;
        dis = null;
      }
    }
    catch (Exception e) { HandleError(e, "ReadTreeFromRMS"); }
    }

  }

  void reverseDirsArrays()
  {
    //System.out.print(String.valueOf(dirs_list.length) + "/2=" + String.valueOf(dirs_list.length / 2));
    String rs=null;
    int is = 0;
    for(i=0; i<dirs_list.length/2; i++)
    {
      //System.out.println(String.valueOf(i));
      rs = dirs_list[i];
      is = dirs_skip[i];
      dirs_skip[i]=dirs_skip[dirs_list.length - 1 - i];
      dirs_skip[dirs_list.length - 1 - i] = is;
      dirs_list[i]=dirs_list[dirs_list.length - 1 - i];
      dirs_list[dirs_list.length - 1 - i] = rs;
    }
  }

  void WriteTreeToRMS()
  {
    RecordStore rs=null;
    //try {
    //  RecordStore.deleteRecordStore("tree"+root);
    //}
    //catch (Exception e) { System.err.println("[FILEMANAGER EXCEPTION]: " + e.toString()); }
    try {
      rs = RecordStore.openRecordStore("tree"+root,true);
      RecordEnumeration re = rs.enumerateRecords(null, null, false);
      while (re.hasNextElement())
      {
        rs.deleteRecord(re.nextRecordId());
      }
      rs.closeRecordStore();
      rs = RecordStore.openRecordStore("tree"+root,true);
      ByteArrayOutputStream bos=null;
      DataOutputStream dos=null;
      for (i=0; i<dirs_list.length; i++)
      {

      bos = new ByteArrayOutputStream();
      dos = new DataOutputStream(bos);
      dos.writeUTF(dirs_list[i]);
      dos.writeInt(dirs_skip[i]);
      //System.out.println("WRITING " + dirs_list[i] + " (skip: " + dirs_skip[i] + ")");
      byte [] a = bos.toByteArray();
      rs.addRecord(a, 0, a.length);
      }
      rs.closeRecordStore();
    }
    catch (Exception e) { HandleError(e, "WriteTreeToRMS"); }

  }

  void DrawTree()
  {
    tree = Image.createImage(256, dirs_list.length * SYMBOL_HEIGHT + dirs_list.length  * 2);
    Graphics g = tree.getGraphics();
    for (i=0; i<dirs_list.length; i++)
    {
    //System.out.println("DRAW TREE PRINTIN' TO IM: " + dirs_list[i] + ", skip: " + String.valueOf(dirs_skip[i]));
    g.drawImage(fold_sm,0+dirs_skip[i]*SKIP_LEN,i*SYMBOL_HEIGHT+i*2,0);
    g.drawImage(string2Image(getLastURLPart(dirs_list[i], true)), 10+SKIP_LEN*dirs_skip[i], i*SYMBOL_HEIGHT+i*2, 0);
    }
  }

  void RenderTree(String dir, int skip, boolean adddirasroot)
  {
    //System.out.println("RENDER TREE CALL: " + dir + " with skip " +String.valueOf(skip));
    //Graphics g = getGraphics();
    //g.setColor(255,255,255);
    //g.fillRect(0,0,getWidth(),getHeight());
    //g.setColor(0,0,0);
    if (adddirasroot)
    {
      skip++;
      dirs_tmp[g_point]=dir;
      skip_tmp[g_point]=0;
      g_point++;
    }
    String [] dirs = ListFolders(dir);
    for (int i=1; i<dirs.length; i++)
    {
      dirs_tmp[g_point] = dirs[i];
      skip_tmp[g_point] = skip;
      g_point++;
      //System.out.println("FOLDERS LISTING... TOTAL: "+String.valueOf(dirs.length));
      //System.out.println("EXECUTING CALL OF RENDERTREE: "+dirs[i]+" with skip " + String.valueOf(skip+1) );
      RenderTree(dirs[i],skip+1,false);

    }
    dirs=null;

  }

  void enterMainLoop()
  {
    exiting = false;
    dirs_list = new String[g_point];
    dirs_skip = new int[g_point];

    System.arraycopy(skip_tmp,0,dirs_skip,0,g_point);
    System.arraycopy(dirs_tmp,0,dirs_list,0,g_point);

    skip_tmp=null;
    dirs_tmp=null;

    if (updated) WriteTreeToRMS();
    if (!updated) reverseDirsArrays();

    DrawTree();
    DrawSelectionLines(0,0,tree.getGraphics());
    disp.setCurrent(this);
    MainLoop();
  }

  void MainLoop()
  {
    //while(!exiting)
    //{
      /*getGraphics().setColor(255,0,0);
      getGraphics().fillRect(0,0,100,100);
      getGraphics().drawImage(string2Image("mobile2"), 1, 1, 0);
      getGraphics().drawImage(font,0,0,0);
      flushGraphics(0,0,128,116);
      getGraphics().setColor(255,0,0);
      getGraphics().fillRect(0,0,100,100);
      getGraphics().drawImage(string2Image("mobile2"), 1, 1, 0);
      getGraphics().drawImage(font,0,0,0);
      //flushGraphics();*/
      repaint();
    //}
  }

  public void HandleError(Exception what, String where)
  {
    Alert ErrorOut = new Alert("Exception occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    ErrorOut.addCommand(exit);
    System.err.println("[FILEMANAGER EXCEPTION]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public void HandleError2(Error what, String where)
  {
    Alert ErrorOut = new Alert("Error occured", what.toString() + " : " + what.getMessage() + " : ocurred at "+where, null, AlertType.ERROR);
    ErrorOut.setTimeout(Alert.FOREVER);
    ErrorOut.addCommand(exit);
    System.err.println("[FILEMANAGER ERROR]: "+what.toString() + " : " + what.getMessage() + " : ocurred at "+where);
    disp.setCurrent(ErrorOut);
  }

  public String getFirstURLPart(String URL)
  {
      int idx = 0;
      idx = URL.indexOf("/");
      if (idx!=-1) URL = URL.substring(0,idx);
      return URL;
  }

  public String getLastURLPart(String URL, boolean hasFinalSlash)
  {
      int idx1=0;
      int idxf=-1;
      int pidxf=-1;
      int z;
      idxf = URL.lastIndexOf('/');
      if (hasFinalSlash)
      {
        if (idxf!=-1) pidxf=URL.lastIndexOf('/',idxf-1);
        URL = URL.substring(pidxf+1,idxf);
      }
      else
      {
        URL = URL.substring(idxf+1);
      }
      return URL;
  }

  String [] ListFolders(String dir)
  {
    int point=0;
    String [] res=new String[1000];
    res[0]="";
    try {
    fc = null;
    fc=(FileConnection) Connector.open("file://"+dir); // Establish FileConnection with current directory
    String [] files = fc.list(); // All files and dirs
    fc.close();
    for (i=0; i<files.length; i++)
    {
      // Check if dir
      fc = null;
      fc = (FileConnection) Connector.open("file://"+root+files[i]);
      if (fc.isDirectory()) {
        point++;
        res[point]=files[i];
      }
      fc.close();
    }
    files=null;
    // List hidden dirs
    String curfn = "";
    boolean addtolist=false;
    AsciiTextFile atf=new AsciiTextFile();
    atf.openFile("/hiddendirs.lst");
    while(!atf.eof())
    {
      curfn = atf.readLine();
      if (curfn.startsWith(dir))
      {
        curfn = curfn.substring(dir.length());
        curfn = getFirstURLPart(curfn);
        curfn = dir + curfn + "/";
        addtolist = isExists(curfn,true);
        if (dir==curfn) addtolist=false;
        //addtolist=true;
        for (i=1; i<=point; i++)
        {
          if (!addtolist) break;
          if (curfn.compareTo(res[i])==0)
          { addtolist = false; break; }
          //System.out.println(String.valueOf(curfn.compareTo(res[i])));
        }
        if (addtolist)
        {
          point++;
          res[point]=curfn;

          //if (hidden_subfolders_begin==0) hidden_subfolders_begin=point;
        }
      }
    }
    atf.close();
    atf = null;
    }
    catch (Exception e) { HandleError(e, "ListFolders"); }
    String [] res2 = new String[point+1];
    System.arraycopy(res, 0, res2, 0, point+1);
    //for (i=0; i<=point; i++) res2[i]=res[i];
    res = null;
    return res2;
  }

  boolean isExists(String fname,boolean isDir)
  {
    boolean a=false;
    try {
      fc = (FileConnection) Connector.open("file://"+fname);
      a = fc.exists();
      fc.close();
    }
    catch (Exception e) { HandleError(e, "isExists"); }
    return a;
  }

  Image string2Image(String s)
  {
    int width=s.length()*SYMBOL_WIDTH;
    int height=SYMBOL_HEIGHT;
    //System.out.println("WIDTH: "+String.valueOf(width)+"HEIGHT: "+String.valueOf(height));
    Image res=Image.createImage(width, height);
    Image tmp=Image.createImage(SYMBOL_WIDTH,SYMBOL_HEIGHT);
    Graphics g = res.getGraphics();
    Graphics g2 = tmp.getGraphics();
    for (int i=0; i<s.length(); i++)
    {
      //System.out.println("LOOKING FOR: "+String.valueOf(s.charAt(i)));
      int code = ascii_ord(s.charAt(i));
      int xpos=code-1;
            //System.out.println("XPOS: "+String.valueOf(xpos) );
      xpos = SYMBOL_WIDTH*xpos;
                 // System.out.println("XPOS: "+String.valueOf(xpos) );
      xpos = -1*xpos;
                 // System.out.println("XPOS: "+String.valueOf(xpos) );
      //System.out.println("COPYING FONT TO: " + String.valueOf(xpos) + ",0");
      g2.setColor(255,255,255);
      g2.fillRect(0,0,tmp.getWidth(), tmp.getHeight());
      g2.drawImage(font,xpos, 0, 0);
      xpos=i*SYMBOL_WIDTH;
                  //System.out.println("XPOS: "+String.valueOf(xpos) );
      g.drawImage(tmp,xpos,0,0);
    }
    return res;
  }

  int ascii_ord(char ch)
  {
    for (int i=1; i<ascii.length; i++)
    {
      if (ch==ascii[i]) { /*System.out.println("CHAR FOUND: "+String.valueOf(i));*/ return i; }
    }
    return 1;
  }

  public void paint(Graphics g) {
    //g.setColor(255,255,255);
    //g.fillRect(0,0,getWidth(),getHeight());
    //flushGraphics(0, -20, getWidth(), getHeight());
    //System.out.println("Flushing graphics: 0, " + String.valueOf(im_y) + ", " + String.valueOf(getWidth()) + ", " + String.valueOf(getHeight()));
    g.drawImage(tree,0,-1*im_y,0);
    //g.fillRect(0,0,getWidth(),getHeight());
  }

  public void DrawSelectionLines(int s_line, int p_line, Graphics g)
  {
      g.setColor(255,255,255);
      int p_line_y1 = (p_line * SYMBOL_HEIGHT + 2 * p_line)-1;
      if (p_line_y1 < 0) p_line_y1 = 0;
      g.drawLine(0,p_line_y1,getWidth(),p_line_y1);
      g.drawLine(0,((p_line+1) * SYMBOL_HEIGHT + 2 * (p_line+1))-2,getWidth(),((p_line+1) * SYMBOL_HEIGHT + 2 * (p_line+1))-2);
      g.setColor(0,0,255);
      g.drawLine(0,line_y,getWidth(),line_y);
      g.drawLine(0,((s_line+1) * SYMBOL_HEIGHT + 2 * (s_line+1))-2,getWidth(),((s_line+1) * SYMBOL_HEIGHT + 2 * (s_line+1))-2);
  }

  public void freeMem()
  {
  ascii = null;
  font=null;
  fold_sm=null;
  tree=null;
  dirs_skip = null;
  dirs_tmp = null;
  skip_tmp = null;
  fc=null;
  disp=null;
  System.gc();
  }

  public void keyPressed(int keycode)
  {
    if (Canvas.UP==getGameAction(keycode))
    {
      p_line = s_line;
      s_line--;
      if (s_line<0) { s_line=0; }
      line_y = (s_line * SYMBOL_HEIGHT + 2 * s_line)-1;
       if (line_y < 0) line_y=0;

      if (im_y>line_y) im_y = line_y;
      DrawSelectionLines(s_line,p_line,tree.getGraphics());
      repaint();
    }

    if (Canvas.DOWN==getGameAction(keycode))
    {
      p_line = s_line;
      s_line++;
      if (s_line>dirs_list.length-1) { s_line=dirs_list.length-1; }
      line_y = (s_line * SYMBOL_HEIGHT + 2 * s_line)-1;
       if (line_y < 0) line_y=0;

      if (im_y + getHeight() < (s_line+1)*SYMBOL_HEIGHT + 2*(s_line+1)) im_y = (s_line+1)*SYMBOL_HEIGHT + 2*(s_line+1) - getHeight();
      DrawSelectionLines(s_line, p_line, tree.getGraphics());
      repaint();
    }

    if (keycode == Canvas.KEY_NUM3)
    {
      p_line = s_line;
      s_line=0;
      line_y = 0;
      if (im_y>line_y) im_y = line_y;
      DrawSelectionLines(s_line,p_line,tree.getGraphics());
      repaint();
    }

    /*if (keycode == Canvas.KEY_NUM5)
    {
      freeMem();
      Callback.tree_ui_callback(dirs_list[s_line], this);
    }*/

    if (getGameAction(keycode)==Canvas.FIRE && keycode!=Canvas.KEY_NUM5)
    {
      freeMem();
      if (s_line!=0 && s_line!=1) { Callback.tree_ui_callback(dirs_list[s_line],this,false,false); }
      if (s_line==0) { Callback.tree_ui_callback("",this,true,false); }
      if (s_line==1) { Callback.tree_ui_callback("",this,false,true); }
    }

    if (keycode==Canvas.KEY_NUM9)
    {
      p_line = s_line;
      s_line=dirs_list.length - 1;
      line_y = (s_line * SYMBOL_HEIGHT + 2 * s_line)-1;
      if (line_y < 0) line_y=0;
      if (im_y + getHeight() < (s_line+1)*SYMBOL_HEIGHT + 2*(s_line+1)) im_y = (s_line+1)*SYMBOL_HEIGHT + 2*(s_line+1) - getHeight();
      DrawSelectionLines(s_line, p_line, tree.getGraphics());
      repaint();
    }
  }

  public void commandAction(Command c, Displayable d)
  {
    if (c==update) { UpdateTree(); enterMainLoop(); }
    if (c==exit) { Callback.tree_ui_callback("",this,false,false); }
  }
}